import { IMagickImage } from './magick-image';
import { IMagickImageCollection } from './magick-image-collection';
import { MagickColor } from './magick-color';
import { MagickReadSettings } from './settings/magick-read-settings';
export declare class ImageMagick {
    private readonly loader;
    private api?;
    private constructor();
    static _create: () => ImageMagick;
    static read(color: MagickColor, width: number, height: number, func: (image: IMagickImage) => void): void;
    static read(color: MagickColor, width: number, height: number, func: (image: IMagickImage) => Promise<void>): Promise<void>;
    static read(fileName: string, func: (image: IMagickImage) => void): void;
    static read(fileName: string, func: (image: IMagickImage) => Promise<void>): Promise<void>;
    static read(array: Uint8Array, func: (image: IMagickImage) => void): void;
    static read(array: Uint8Array, func: (image: IMagickImage) => Promise<void>): Promise<void>;
    static read(fileName: string, settings: MagickReadSettings, func: (image: IMagickImage) => void): void;
    static read(fileName: string, settings: MagickReadSettings, func: (image: IMagickImage) => Promise<void>): Promise<void>;
    static read(array: Uint8Array, settings: MagickReadSettings, func: (image: IMagickImage) => void): void;
    static read(array: Uint8Array, settings: MagickReadSettings, func: (image: IMagickImage) => Promise<void>): Promise<void>;
    static readCollection(fileName: string, func: (images: IMagickImageCollection) => void): void;
    static readCollection(fileName: string, func: (images: IMagickImageCollection) => Promise<void>): Promise<void>;
    static readCollection(array: Uint8Array, func: (images: IMagickImageCollection) => void): void;
    static readCollection(array: Uint8Array, func: (image: IMagickImageCollection) => Promise<void>): Promise<void>;
    static readCollection(fileName: string, settings: MagickReadSettings, func: (images: IMagickImageCollection) => void): void;
    static readCollection(fileName: string, settings: MagickReadSettings, func: (images: IMagickImageCollection) => Promise<void>): Promise<void>;
    static readCollection(array: Uint8Array, settings: MagickReadSettings, func: (images: IMagickImageCollection) => void): void;
    static readCollection(array: Uint8Array, settings: MagickReadSettings, func: (images: IMagickImageCollection) => Promise<void>): Promise<void>;
    static readFromCanvas(canvas: HTMLCanvasElement, func: (image: IMagickImage) => void): void;
    static readFromCanvas(canvas: HTMLCanvasElement, func: (image: IMagickImage) => Promise<void>): Promise<void>;
}
export declare function initializeImageMagick(): Promise<void>;
